#!/bin/sh
#	Copyright 2003, Free Standards Group
#	Copyright 2003, IBM Corp.
#
#	George Kraft IV <gk4@austin.ibm.com>
#
#	Setup for lsb-vsw4 testing.
#

user_vsw4() {

	id vsw4 > /dev/null 2>&1
	if [ $? -ne 0 ]; then
		echo "Add user vsw4 for testing."
		su -c "/usr/sbin/useradd -m -d /home/lsb-vsw4 vsw4"
	fi
}

tet_environ() {
	
	case "$SHELL" in
		/bin/bash)
			PROFILE=$HOME/.bash_profile
			;;
		/bin/sh)
			PROFILE=$HOME/.profile
			;;
		/bin/ksh|/bin/pdksh)
			PROFILE=$HOME/.profile
			;;
	esac

	grep TET_ROOT $PROFILE > /dev/null 2>&1
	if [ $? -ne 0 ]; then
		echo "export TET_ROOT" >> $PROFILE
		echo "TET_ROOT=$(dirname ~vsx0)" >> $PROFILE
	fi

	grep TEST_SUITE_ROOT $PROFILE > /dev/null 2>&1
	if [ $? -ne 0 ]; then
		echo "export TEST_SUITE_ROOT" >> $PROFILE
		echo "TEST_SUITE_ROOT=$(echo ~vsw4)" >> $PROFILE
	fi

	which tcc > /dev/null 2>&1
	if [ $? -ne 0 ]; then
		id vsx0 > /dev/null 2>&1
		if [ $? -ne 0 ]; then
			echo "Is does not look like user vsx0 exits."
			echo "Install the lsb-runtime-test package."
		elif [ -x ~vsx0/../bin/tcc ]; then
			echo "PATH=\$PATH:$(echo ~vsx0/../bin)" >> $PROFILE
		else
			echo "Could not find ~vsx0/../bin/tcc in PATH."
		fi
	fi
}

user_vsw4
tet_environ
