/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: dfltrtwdw.m,v 1.6 92/06/11 15:57:18 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   Window
 *   XDefaultRootWindow(display)
 *   Display	*display;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XDefaultRootWindow	1
char    *TestName = "XDefaultRootWindow";

/*
 * Defines for different argument types
 */
#define A_DISPLAY display


/*
 * Arguments to the XDefaultRootWindow function
 */
static Display	*display;


int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	display = Dsp;
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XDefaultRootWindow-1.(A)
 * A call to XDefaultRootWindow returns the root window of the
 * default screen.
 */
static void
t001()
{
Window			dwin;
XWindowAttributes	atts;
int			screen_number;
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();

	screen_number = DefaultScreen(display);

	startcall(display);
	if (isdeleted())
		return;
	dwin = XDefaultRootWindow(display);
	endcall(display);
	if (geterr() != Success) {
		report("Got %s, Expecting Success", errorname(geterr()));
		FAIL;
	}
	if(XGetWindowAttributes(display, RootWindow(display, screen_number), &atts) == 0) {	
		delete("XGetWindowAttributes() returned 0.");
		return;
	} else
		CHECK;

	if(dwin != atts.root) {
		report("The default root window ID was %lx instead of %lx.", (long) dwin, (long) atts.root);
		FAIL;
	} else
		CHECK;

	CHECKPASS(2);
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
