/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: insrtmdfrm.m,v 1.4 92/06/11 17:14:39 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   XModifierKeymap *
 *   XInsertModifiermapEntry(modmap, keycode_entry, modifier)
 *   XModifierKeymap	*modmap;
 *   KeyCode	keycode_entry;
 *   int 	modifier;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XInsertModifiermapEntry	1
char    *TestName = "XInsertModifiermapEntry";

/*
 * Defines for different argument types
 */


/*
 * Arguments to the XInsertModifiermapEntry function
 */
static XModifierKeymap	*modmap;
static KeyCode	keycode_entry;
static int 	modifier;



static XModifierKeymap	*Modmap;


int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	modmap = Modmap;
	keycode_entry = 0;
	modifier = 0;
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XInsertModifiermapEntry-1.(A)
 * A call to XInsertModifiermapEntry adds the specified
 * KeyCode, keycode_entry, to the set that controls the
 * specified modifier and returns a pointer to the modified
 * XModifierKeymap structure.
 */
static void
t001()
{
struct	kcmod {
	KeyCode	kc;
	int 	mod;
	int 	found;
};
static	struct	kcmod	kcmod[] = {
	{0x34, ShiftMapIndex},
	{0x56, Mod3MapIndex},
	{0x76, ControlMapIndex},
	{0x77, ControlMapIndex},
	{0xF6, Mod3MapIndex},
};
int 	i;
int 	set;
extern	int 	NS_modifier;
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();

	modmap = XNewModifiermap(0);
	if (modmap == 0) {
		delete("Could not create modifiermap");
		return;
	}

	for (i = 0; i < NELEM(kcmod); i++) {
		keycode_entry = kcmod[i].kc;
		modifier = kcmod[i].mod;

		startcall(Dsp);
		if (isdeleted())
			return;
		modmap = XInsertModifiermapEntry(modmap, keycode_entry, modifier);
		endcall(Dsp);
		if (geterr() != Success) {
			report("Got %s, Expecting Success", errorname(geterr()));
			FAIL;
		}

		kcmod[i].found = 0;
	}

	for (i = 0; i < NELEM(kcmod); i++) {
		/* Look in the map */
		for (set = 0; set < modmap->max_keypermod; set++) {
			if (modmap->modifiermap[kcmod[i].mod*modmap->max_keypermod+set]==kcmod[i].kc)
				kcmod[i].found++;
		}
	}

	for (i = 0; i < NELEM(kcmod); i++) {
		if (kcmod[i].found)
			CHECK;
		else {
			report("Keycode 0x%x, modifier %s not added to map",
				kcmod[i].kc, modifiername(kcmod[i].mod));
			FAIL;
		}
	}

	CHECKPASS(NELEM(kcmod));
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
