/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: allcstndrd.m,v 1.6 92/06/11 17:27:07 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   XStandardColormap *
 *   XAllocStandardColormap()
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XAllocStandardColormap	1
char    *TestName = "XAllocStandardColormap";



int 	tet_thistest;

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XAllocStandardColormap-1.(A)
 * A call to XAllocStandardColormap allocates and returns a
 * pointer to a XStandardColormap structure, which can be freed
 * with XFree in which each component is set to zero.
 */
static void
t001()
{
XStandardColormap	*scmp = (XStandardColormap *) NULL;
int 	pass = 0, fail = 0;

	tpstartup();

	scmp = XAllocStandardColormap();

	if(scmp == (XStandardColormap *) NULL) {
		delete("%s() returned NULL.", TestName);
		return;
	} else
		CHECK;

	if(scmp->colormap != (Colormap) 0) {
		report("The colormap component of the XStandardColormap structure was non-zero.");
		FAIL;
	} else
		CHECK;

	if(scmp->red_max != 0L) {
		report("The red_max component of the XStandardColormap structure was non-zero.");
		FAIL;
	} else
		CHECK;

	if(scmp->red_mult != 0L) {
		report("The red_mult component of the XStandardColormap structure was non-zero.");
		FAIL;
	} else
		CHECK;

	if(scmp->green_max != 0L) {
		report("The green_max component of the XStandardColormap structure was non-zero.");
		FAIL;
	} else
		CHECK;

	if(scmp->green_mult != 0L) {
		report("The green_mult component of the XStandardColormap structure was non-zero.");
		FAIL;
	} else
		CHECK;

	if(scmp->blue_max != 0L) {
		report("The blue_max component of the XStandardColormap structure was non-zero.");
		FAIL;
	} else
		CHECK;

	if(scmp->blue_mult != 0L) {
		report("The blue_mult component of the XStandardColormap structure was non-zero.");
		FAIL;
	} else
		CHECK;

	if(scmp->base_pixel != 0L) {
		report("The base_pixel component of the XStandardColormap structure was non-zero.");
		FAIL;
	} else
		CHECK;

	if(scmp->visualid != (VisualID) 0) {
		report("The visualid component of the XStandardColormap structure was non-zero.");
		FAIL;
	} else
		CHECK;

	if(scmp->killid != (XID) 0) {
		report("The killid component of the XStandardColormap structure was non-zero.");
		FAIL;
	} else
		CHECK;

	XFree((char*)scmp);

	CHECKPASS(11);

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion XAllocStandardColormap-2.(B)
 *   Reason: There is no known portable test method for this assertion
 * When insufficient memory is available, then a call to
 * XAllocStandardColormap returns NULL.
 */
static void
t002()
{
	report("There is no known portable test method for this assertion");
	UNTESTED;
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	t002, 2,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
